Arvados - Bug #15241

[a-c-r] crashing using collection in writable initialWorkDir
05/17/2019 03:29 PM - Peter Amstutz
Description

- class: InitialWorkDirRequirement
listing:
- entry: $(inputs.geneBankFilesDir)
writable: true

"keep:e4b03abaf2b9912£3823d19bd78£296b+219": [
"keep:e4b03abaf2b9912£3823d19bd78£296b+219",
"/var/spool/cwl/edb03abaf2b9912£3823d19bd78£296b+219",
"WritableDirectory",
false

1,

Traceback (most recent call last):

File "/usr/lib/python2.7/site-packages/arvados_cwl/executor.py", line 700, in arv_executor
self.start_run (runnable, runtimeContext)

File "/usr/lib/python2.7/site-packages/arvados_cwl/executor.py", line 219, in start_run
self.workflow_eval_lock, self.stop_polling)

File "/usr/lib/python2.7/site-packages/arvados_cwl/task_queue.py", line 44, in add
task ()

File "/usr/lib/python2.7/site-packages/arvados_cwl/arvcontainer.py", line 152, in run
vwd.copy (path, p.target, source_collection=source)

File "/usr/lib/python2.7/site-packages/arvados/arvfile.py", line 472, in must_be_writable_wrappe

i3
return orig_func(self, *args, **kwargs)
File "/usr/lib/python2.7/site-packages/arvados/arvfile.py", line 273, in synchronized_wrapper
return orig_func(self, *args, **kwargs)
File "/usr/lib/python2.7/site-packages/arvados/collection.py", line 923, in copy
target_dir.add(source_obj, target_name, overwrite, False)
File "/usr/lib/python2.7/site-packages/arvados/arvfile.py", line 472, in must_be_writable_wrappe
i3

return orig_func(self, *args, **kwargs)

File "/usr/lib/python2.7/site-packages/arvados/arvfile.py", line 273, in synchronized_wrapper
return orig_func(self, *args, **kwargs)

File "/usr/lib/python2.7/site-packages/arvados/collection.py", line 849, in add

item = source_obj.clone(self, target_name)
AttributeError: 'NoneType' object has no attribute 'clone'

The problem is that get_collection() returns None for path when there is no path in the keep: URI. The None gets passed into
vwd.copy() and causes it to crash.

It should probably be changed to path or "." so that it refers to the whole collection in that case.

Write a test case to confirm the bug & the fix.
Merge branch '15241-collection-input' refs #15241

Arvados-DCO-1.1-Signed-off-by: Peter Amstutz <pamstutz@veritasgenetics.com>

Revision 0559157e - 05/20/2019 08:42 PM - Peter Amstutz

11/29/2021 1/2



mailto:pamstutz@veritasgenetics.com

Fix cwl tests refs #15241

Arvados-DCO-1.1-Signed-off-by: Peter Amstutz <pamstutz@veritasgenetics.com>

History

#1 - 05/17/2019 03:29 PM - Peter Amstutz

- Status changed from New to In Progress

#2 - 05/17/2019 03:29 PM - Peter Amstutz

- Subject changed from [a-c-r] crashing using writable collection in initialWorkDir to [a-c-r] crashing using collection in writable initialWorkDir

#3 - 05/17/2019 03:39 PM - Peter Amstutz

- Description updated

#4 - 05/20/2019 07:49 PM - Peter Amstutz

- Status changed from In Progress to Resolved

#5 - 05/21/2019 10:27 PM - Tom Morris

- Release setto 15
